﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Syncfusion.EJ.ReportViewer;
using System.Collections;
using Syncfusion.Reports.EJ;
using System.IO;
using System.Threading;
using System.Windows.Forms;
using System.Net.Mail;
using System.Net.Mime;

namespace RDLReportSample.WebAPI
{
    public class RDLReportController : ApiController, IReportController
    {
        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null && jsonResult.ContainsKey("resourcetype"))
            {
                var _stream = ReportHelper.GetReport(jsonResult["controlID"].ToString(), "Html");
                _stream.Position = 0;
                StreamReader _reader = new StreamReader(_stream);
                var mailBody = _reader.ReadToEnd();
                mailBody = mailBody.Replace("<HTML>", "<html><meta http-equiv=\"X-UA-Compatible\" content=\"IE=9\" />");
                mailBody = mailBody.Replace("</HTML>", "<script>(function () {var rules = document.styleSheets[document.styleSheets.length - 1].rules;for (var idx = 0; idx < rules.length; idx++) {var elements = document.querySelectorAll(rules[idx].selectorText);for (var i = 0; i < elements.length; i++) {elements[i].style.cssText += rules[idx].style.cssText;}}var _length = rules.length;for (var i = 0; i < _length; i++) {document.styleSheets[document.styleSheets.length - 1].removeRule(0);}document.styleSheets[document.styleSheets.length - 1] = [];document.scripts[document.scripts.length - 1] = [];})();</script></html>");
                var t = new Thread(delegate ()
                {
                    System.Windows.Forms.WebBrowser _webBrowser = new System.Windows.Forms.WebBrowser();
                    _webBrowser.DocumentText = mailBody;
                    do
                    {
                        System.Windows.Forms.Application.DoEvents();
                        Thread.Sleep(500);
                    } while (_webBrowser.ReadyState != System.Windows.Forms.WebBrowserReadyState.Complete || _webBrowser.IsBusy);
                    mailBody = "<html><body>" + _webBrowser.Document.Body.InnerHtml + "</body></html>";
                });

                t.SetApartmentState(ApartmentState.STA);
                t.Start();
                t.Join();

                var _HtmlStream = ReportHelper.GetReport(jsonResult["controlID"].ToString(), "Html");
                _HtmlStream.Position = 0;

                var data = ReportHelper.GetResource(jsonResult["controlID"].ToString(), "Html", false);
                this.SendMsg(_HtmlStream, mailBody, jsonResult["reportName"].ToString());
            }
            return ReportHelper.ProcessReport(jsonResult, this);
        }

        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            reportOption.ReportModel.ReportServerCredential = new System.Net.NetworkCredential("IvySSRS", "Ivy!6985");
            reportOption.ReportModel.DataSourceCredentials.Add(new Syncfusion.Reports.EJ.DataSourceCredentials("IvyCollection", "IvyAppLogin@qna92gmvnh.database.windows.net", "Ivy!7193"));
        }

        public void OnReportLoaded(ReportViewerOptions reportOption)
        {

        }

        public bool SendMsg(Stream str, string mailBody, string reportName)
        {
            try
            {
                MailMessage mail = new MailMessage();
                SmtpClient SmtpServer = new SmtpClient("smtp.gmail.com");
                mail.IsBodyHtml = true;
                mail.From = new MailAddress("mahe061195.shan@gmail.com");
                mail.To.Add("mahendran.shanmugam@syncfusion.com");
                mail.Subject = "Report_Name : " + reportName + " paramName : ";
                str.Position = 0;
                if (str != null)
                {
                    mail.Body = mailBody;
                    ContentType ct = new ContentType();
                    ct.Name = "report" + DateTime.Now.ToString() + ".html";
                    System.Net.Mail.Attachment attachment = new System.Net.Mail.Attachment(str, ct);
                    mail.Attachments.Add(attachment);
                }

                SmtpServer.Port = 587;
                SmtpServer.Credentials = new System.Net.NetworkCredential("mahe061195.shan@gmail.com", "xxxxxxxx");
                SmtpServer.EnableSsl = true;
                SmtpServer.Send(mail);
                return true;
            }
            catch (Exception ex)
            {
                ex.ToString();
            }

            return false;
        }
    }
}